unit Unit1;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, TeEngine, TeeOrgSeries, DB, DBTables, ExtCtrls, TeeProcs, Chart,
  DBChart, Series, TeeComma, StdCtrls, ComCtrls;

type
  TForm1 = class(TForm)
    Chart1: TChart;
    TeeCommander1: TTeeCommander;
    UpDown1: TUpDown;
    Edit1: TEdit;
    Label1: TLabel;
    Edit2: TEdit;
    Edit3: TEdit;
    Label2: TLabel;
    Label3: TLabel;
    procedure FormCreate(Sender: TObject);
    procedure Chart1AddSeries(Sender: TCustomChartSeries);
    procedure Chart1GetLegendText(Sender: TCustomAxisPanel;
      LegendStyle: TLegendStyle; Index: Integer; var LegendText: string);
    procedure Edit2Change(Sender: TObject);
    procedure UpDown1Click(Sender: TObject; Button: TUDBtnType);
    procedure Chart1MouseMove(Sender: TObject; Shift: TShiftState; X,
      Y: Integer);
    procedure Edit3Change(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  Form1: TForm1;

implementation

{$R *.dfm}

var SeriesStrings: array of String;
    NumEls: Integer;

procedure TForm1.FormCreate(Sender: TObject);
begin
  NumEls:=0;

  Chart1.AddSeries(TAreaSeries.Create(self));
  Chart1.AddSeries(TLineSeries.Create(self));

  Chart1[0].FillSampleValues;
  Chart1[1].FillSampleValues;

  Chart1[0].Title:='Area Series';
  Chart1[1].Title:='Line Series';

  SeriesStrings[0]:='AreaTag';
  SeriesStrings[1]:='LineTag';

  Chart1.Legend.LegendStyle:=lsSeries;

  UpDown1.Max:=Chart1.SeriesCount-1;
  Edit2.Text:=Chart1[UpDown1.Position].Title;
  Edit3.Text:=SeriesStrings[Chart1[UpDown1.Position].Tag];
end;

procedure TForm1.Chart1AddSeries(Sender: TCustomChartSeries);
begin
  SetLength(SeriesStrings,NumEls + 1);
  SeriesStrings[NumEls]:='Series ' + IntToStr(Chart1.SeriesCount-1);
  Chart1[Chart1.SeriesCount-1].Tag:=Chart1.SeriesCount-1;
  NumEls:=NumEls+1;
  UpDown1.Max:=Chart1.SeriesCount-1;
end;

procedure TForm1.Chart1GetLegendText(Sender: TCustomAxisPanel;
  LegendStyle: TLegendStyle; Index: Integer; var LegendText: string);
var i, ActiveSeriesCount: Integer;
begin
  i:=0;
  ActiveSeriesCount:=0;

  while ((not Chart1[i].Active) or (ActiveSeriesCount<>Index)) do
  begin
    if Chart1[i].Active then ActiveSeriesCount:=ActiveSeriesCount+1;
    i:=i+1;
  end;

  LegendText:=SeriesStrings[Chart1[i].Tag];
end;

procedure TForm1.Chart1MouseMove(Sender: TObject; Shift: TShiftState; X,
  Y: Integer);
var i: Integer;
begin
  i:=Chart1.SeriesCount-1;
  while ((i>=0) and (Chart1[i].Clicked(X,Y)=-1)) do
    i:=i-1;

  if i>=0 then
    Chart1.Title.Text.Text:=Chart1[i].Title
  else
    Chart1.Title.Text.Text:=' ';
end;

procedure TForm1.UpDown1Click(Sender: TObject; Button: TUDBtnType);
begin
  Edit2.Text:=Chart1[UpDown1.Position].Title;
  Edit3.Text:=SeriesStrings[Chart1[UpDown1.Position].Tag];
end;

procedure TForm1.Edit2Change(Sender: TObject);
begin
  Chart1[UpDown1.Position].Title:=Edit2.Text;
end;

procedure TForm1.Edit3Change(Sender: TObject);
begin
  SeriesStrings[Chart1[UpDown1.Position].Tag]:=Edit3.Text;
  Chart1.Repaint;
end;

end.
